{$m 16384,10000,655360, $i-,$d-,$b-,$e-,$f-,$L-,$n-,$r-,$s+,$v-}
{         Minimum heap-size=(sizeof(Buffer)+sizeof(FL))*2+sizeof(FL) }
{                           Currently 8383-Bytes, @1991.12.1         }
{ History:  v-1.00 89-10-03   Single-Drive-File-Copy Recursive-version
            v-1.01 89-10-10   BUG in writeFS is Fixed.
            v-1.02 89-10-30   makes multiple directories
            v-1.04 91-08-25   minor ver-up. not copy if time-stamp is the same
            v-1.06 91-12-01   fixed bug at skipping
            v-1.08 91-12-01   fixed bug at skipping
            v-1.10 91-12-03   reccurion-Flag is set
            v-1.12 91-12-03   system, hidden Flag also set
            v-1.14 91-12-06   parameter-specifying is changed.
}
program Single_Drive_File_Copy;    { for Turbo-Pascal-v5 or later }
uses Dos;
  const
    version    = 'v-1.14 91/12/06 (Fr) nemossan';
    BuffSize   = 4096;
    DAttr      = Dos.Directory or Dos.Hidden   or Dos.ReadOnly;
    WAttr:byte = Dos.ReadOnly;
    FAttr:byte = Dos.Archive   or Dos.ReadOnly or Dos.Directory;
    Indent     = 4;                                          { indent-Level }
  type
    Bfr  = array[1..BuffSize]of byte;
    pBuf = ^Buffer;
    Buffer = record
      Buf  : Bfr;
      next : pBuf
    end;
    FP =^FL;
    FL = record
      sRec     : Dos.SearchRec;
      numRecrd,           { Num of read-Record }
      numByte  : word;    { Num ov read-Byte }
      WCount   : longInt; { total written-byte }
      sAdrBuf  : pointer; { start address of the Buffer }
      eoFF,               { input is EOF }
      skip     : Boolean; { this file should be skipped }
      nextP    : FP
    end;
    decision = (go,    skip);
    dDisk    = (source,dest);

  const Bsize = sizeof(Buffer)+sizeof(FL);

  var
    Level:word;  disk:dDisk;  progName:Dos.NameStr;
    sameDrv:Boolean;  st:string[2];

  const
    psp : integer=1;
    tStamp     : decision = skip;                    { all defaults is SKIP }
    reccursion : decision = skip;
    protect    : decision = skip;
    hFile      : decision = skip;
    sFile      : decision = skip;

{ ---------------------- general procedure/Functions ---------------------- }
  procedure getCSize( Drvnum:word; var CSize:word );
    var reg:Dos.registers;
  begin
    reg.AH:=$1c; reg.DL:=byte(Drvnum); MsDos(reg);
    CSize:=reg.AL*reg.CX
  end;

  Function CLusterSIZE( Size:longInt; CSize:word ):word;
  begin
    if Size mod Csize=0 then CLusterSIZE:=Size div Csize
                        else CLusterSIZE:=Size div Csize + 1
  end;

  procedure get_next(var sRec:Dos.SearchRec; var dError:integer);
  begin
    Dos.FindNext(sRec);   dError:=DosError
  end;

  procedure prepare(dFn:Dos.pathStr; st:string; var skipping:Boolean);
  begin
    writeln(^g'"',dFn,'":'^i^i,st,'.');  skipping:=True
  end;

  procedure make_directory( Dir:Dos.DirStr; dRec:Dos.SearchRec );
    procedure cut_sub( inDir:Dos.DirStr;  var outDir:Dos.DirStr );
      var po:word;
    begin
      po:=Length(inDir);
      while (po>0)and(inDir[po]<>'\') do DEC(po);
      outDir:=Copy(inDir,1,po-1)
    end;
    var dd:Dos.DirStr;  i:integer;
  begin
    dd:=Dir;
    Dos.FindFirst( dd, DAttr, dRec );                   { check Dir exists? }
{$i-}
    if DosError<>0 then begin
      MkDir(dd);
      if ioResult<>0 then begin
        cut_sub( dd, dd);
        make_directory( dd,dRec );
      end;
    end;
    MkDir(Dir);  i:=ioResult;        { reSet ioResult for later use of File }
{$i+}
  end;

{ ---------------------- general procedure/Functions ---------------------- }

  procedure Get_Param( var tStamp,protect,reccursion,sFile,hFile : decision;
                       var src_Fn,Dst_path : Dos.PathStr);
    var
      Dir:Dos.DirStr;  Nam:Dos.NameStr;  Ext:Dos.ExtStr;
      pc:integer;
    procedure help;
    begin
      writeln(^i'Ex: ',progName,' [/trphs] [Dr:[Dir\]]*.pas [Dr:[Dir\]]'^m^j,
              ^i'    ',progName,' [-trphs] [Dr:[Dir\]]*.*   [Dr:][Dir\]'^m^j,
              ^i'    ',progName,' [-t /r ] [Dr:[Dir\]]s*.*  [Dr:[Dir\]]'^m^j);
      writeln(^i'1st-param: option parameters.');
      writeln(^i'   copies even if NEWER File(s)      when "t".');
      writeln(^i'   RECCURSIVEly copies,              when "r".');
      writeln(^i'   copies even if PROTECTED File(s), when "p".');
      writeln(^i'   copies even Hidden-Files,         when "h".');
      writeln(^i'   copies even System-Files,         when "s".');
      writeln(^i'          if not, those Files will be skipped.');
      writeln(^i'2nd-param: input File/Dir, wild-card allowed.');
      writeln(^i'   recursively copies if Dir-name matched and "-r".');
      writeln(^i'3rd-param: Destination-path, if Dir, "\" is necessary.');
      halt
    end;
    procedure select( ch:char; st:string; var action:decision );
    begin
      if (Pos(ch,st)>1)or(Pos(UpCase(ch),st)>1)
        then action:=go else action:=skip
    end;

    const psp : integer = 1;
  begin {Get_Param}
    Dos.FSplit(Dos.FExpand(ParamStr(0)), Dir,Nam,Ext);
    writeln(^j'>>>Single Drive File Copy<<< "'^m^j,
            ^i,Dir+Nam+Ext,'" ',version);
    progName:=Nam;
    pc:=ParamCount;
    if pc=0 then help
    else begin
      st:=Copy(ParamStr(psp),1,1);
      while (st[1]='/')or(st[1]='-') do begin
        select('t',ParamStr(psp),tStamp);
        select('r',ParamStr(psp),reccursion);
        select('p',ParamStr(psp),protect);
        select('h',ParamStr(psp),hFile);
        select('s',ParamStr(psp),sFile);
        INC(psp);
        if pc<psp then help;
        st:=Copy(ParamStr(psp),1,1);
      end;
      src_Fn:=ParamStr(psp);
    end;
    if hFile  =go then begin
      FAttr:=FAttr or Dos.Hidden;   WAttr:=WAttr or Dos.Hidden;
    end;
    if sFile  =go then begin
      FAttr:=FAttr or Dos.SysFile;  WAttr:=WAttr or Dos.Sysfile;
    end;
    if pc>psp then Dst_path:=ParamStr(psp+1) else Dst_Path:='';
    src_Fn  :=Dos.FExpand(src_Fn);  dst_Path:=Dos.FExpand(dst_Path);
    sameDrv :=Copy(src_Fn,1,1)=Copy(Dst_path,1,1);
    writeln('src_Fn: "',src_Fn,'",   dst_path: "',Dst_path,'".')
  end; {Get_Param}

  procedure prompt(str,src_Fn:string; cdisk:dDisk);
  begin
    if sameDrv and (cdisk<>disk) then begin
      write(^g'Insert  ',str,'-disk in ',copy(src_fn,1,1),'-Drive, and ',
              'Hit <RETURN>');
      disk:=cdisk;
      readln                                            { wait until RETRUN }
    end
  end;


  procedure readWrite( src_Fn, Dst_path: Dos.PathStr;
                       tStamp,protect,reccursion,sFile,hFile : decision;
                   var Tnum,LCount     : word);
    var
      sFn,dFn,oFn : Dos.PathStr;
      sRc         : Dos.SearchRec;
      inF,otF : File;
      sB,cB,oB: pBuf;
      Finfo,Cinfo,Oinfo : FP;               { First/Current/Old File-info's }
      dError  : integer;
      skipping:Boolean;

    procedure READing(var dError:integer; var Rnum:word);
      procedure readF;
      begin
        while (not eof(inF))and(MaxAvail>Bsize) do begin
          system.FileMode:=0;                                   { read only }
          BlockRead( inF, cB^.Buf, BuffSize, Cinfo^.numByte );
          INC(Cinfo^.numRecrd);
          oB:=cB;  New(cB);  oB^.next:=cB;  cB^.next:=NIL
        end;
        Cinfo^.eoFF:=eof(inF);
        Close(inF);
      end;
      var Dir:Dos.DirStr;  Nam:Dos.NameStr;  Ext:Dos.ExtStr;
    begin {READing}
      New(sB);  cB:=sB;  sB^.next:=NIL;  Cinfo^.numRecrd:=0;
      Cinfo^.skip:=False;  Cinfo^.eoFF:=False;
      prompt('Source',src_Fn,source);
      while (dError=0)and(MaxAvail>Bsize)and
           ((sRc.Attr and Directory)=0) do begin
        if Cinfo^.WCount=0 then begin               { read this File, first }
          Cinfo^.sRec:=sRc;
          Dos.FSplit(Dos.FExpand(src_Fn),  Dir,Nam,Ext);
          sFn:=Dir+Cinfo^.sRec.Name;
          writeln(' ':Level*Indent,'Reading "',sFn,'".');  INC(Rnum)
        end else if not Cinfo^.skip then
          writeln(^m^j,' ':Level*Indent,'Reading "',sFn,'" again.');
        assign(inF,sFn);  reSet(inF,1);  seek(inF,Cinfo^.WCount);
        Cinfo^.sAdrBuf:=cB;
        readF;                                 { read until EOF/memory-full }
        if Cinfo^.eoFF then get_next(sRc,dError);
        Oinfo:=Cinfo;                          { increase Current File info }
        New(Cinfo);
        Oinfo^.nextP:=Cinfo;
        Cinfo^.nextP:=NIL;   Cinfo^.numRecrd:=0;    Cinfo^.eoFF:=False;
        Cinfo^.skip:=False;  Cinfo^.WCount:=0;
      end;
    end; { READing }

    procedure WRITing(var Wnum:word);
      procedure write1Block(var otF:File;   Cinfo:FP;  var cB:pBuf);
        var size:word;
      begin
        if Cinfo^.numRecrd>1 then size:=Buffsize else size:=Cinfo^.numByte;
        if not Cinfo^.skip then BlockWrite(otF, cB^.Buf, size);
        Cinfo^.WCount:=Cinfo^.WCount + size;
        DEC(Cinfo^.numRecrd);
        cB:=cB^.next;
      end;

      var
        Dir:Dos.DirStr;  Nam:Dos.NameStr;  Ext:Dos.ExtStr;
        dRec:Dos.SearchRec;  DNum:word;    CSize:word;
    begin {WRITing}
      Cinfo:=Finfo;  cB:=sB;  skipping:=False;
      while (Cinfo^.nextP<>NIL) do begin
        prompt(' Dest.',src_Fn,dest);             { Don't move before WHILE }
        oFn:=dFn;  dFn:=Dst_Path+Cinfo^.sRec.Name;
        if (Cinfo^.WCount=0)or(oFn<>dFn) then begin      { write first-time }
          skipping:=False;
          Dos.FSplit(Dos.FExpand(dFn),  Dir,Nam,Ext);
          st:=Copy(Dir,1,2); DNum:=ord(st[1])-ord('@'); getCSize(Dnum,CSize);
          if CLusterSIZE(Dos.DiskFree(DNum),Csize)        { check Free-area }
            <CLusterSIZE(Cinfo^.sRec.size,  Csize) then begin
            writeln('Size of "',Cinfo^.sRec.Name,
                    '" exceeds Free-area of "',st,'".');
            prepare(dFn,'Skipped',skipping)
          end;
          if not skipping then begin
            if (Length(Dir)>3)and(Dir[Length(Dir)]='\') then begin
              Dir:=Copy(Dir,1,Length(Dir)-1);
              make_directory( Dir,dRec );
            end;
            Dos.FindFirst( dFn,FAttr,dRec );   assign(otF,dFn);
            if DosError=0 then begin         { same Fn Found in destination }
              if (Cinfo^.sRec.time<=dRec.time)and(tStamp=skip) then
                prepare(dFn,'Newer/Same-File',skipping);
              if ((dRec.Attr and WAttr)<>0)and(protect=skip) then
                prepare(dFn,'Write-Protected/Hidden/sysFile',skipping);
            end;
          end;
          Cinfo^.skip := skipping;
          if not skipping then begin
            Dos.SetFAttr(otF,Dos.Archive);
            writeln(' ':Level*Indent,'writing "',dFn,'".');  reWrite(otF,1);
            INC(Tnum);  Inc(Wnum)
          end
        end else if not Cinfo^.skip then begin            { already writing }
          writeln(' ':Level*Indent,'writing "',dFn,'" again.');
          assign(otF,dFn); reSet(otF,1);  seek(otF,Cinfo^.WCount);
        end;
        if not Cinfo^.skip then begin
          cB:=Cinfo^.sAdrBuf;
          while (Cinfo^.numRecrd>0) do write1Block(otF,Cinfo,cB);
          Dos.setFTime(otF,Cinfo^.sRec.Time);
          close(otF);
          if Cinfo^.eoFF then Dos.setFAttr( otF,Cinfo^.sRec.Attr );
        end;
        Cinfo:=Cinfo^.nextP;
      end;
    end; { WRITing }

    var
      pp : pointer;
      Wnum,Rnum : word;
      Dir:Dos.DirStr;  Nam:Dos.NameStr;  Ext:Dos.ExtStr;
  begin {ReadWrite}
    st:=Copy(src_Fn,Length(src_Fn),1);
    if (st[1]='\')or(st[1]=':')then src_Fn:=src_Fn+'*.*';
    prompt('Source',src_Fn,source);
    system.FileMode:=0;                                         { read only }
    Dos.FindFirst( src_Fn, FAttr, sRc );   dError:=DosError;
    while (dError=0)and((sRc.attr and Dos.Directory)<>0)and     { skip ./.. }
         ((sRc.name='.')or(sRc.Name='..')) do get_next(sRc,dError);
    if reccursion=skip then
      while (dError=0)and((sRc.attr and Dos.Directory)<>0)
        do get_next(sRc,dError);
    Wnum:=0;  Rnum:=0;  dFn:='';  INC(Level);  INC(LCount);
    New(Finfo);
    Finfo^.WCount:=0;   Finfo^.numRecrd:=0;
    Finfo^.skip:=False; Finfo^.eoFF:=False;
    Oinfo := Finfo;
    while dError=0 do begin
      if reccursion=skip then
        while (dError=0)and((sRc.attr and Dos.Directory)<>0)
          do get_next(sRc,dError);
      Mark(pp);
      Cinfo:=Finfo;  Cinfo^.nextP:=NIL;
      if (dError=0)and( (sRc.Attr and Directory)<>0 ) and (reccursion=go)
      then begin { Dir name }
        Finfo^.WCount:=0;
        Dos.FSplit(src_Fn,  Dir,Nam,Ext);
        readWrite( Dir+sRc.name+'\', Dos.FExpand(Dst_path)+sRc.Name+'\',
                   tStamp,protect,reccursion,sFile,hFile,
                   Tnum,LCount);              { reccursive call for sub-dir }
        get_next(sRc,dError)
      end;
      system.FileMode:=0;                                       { read only }
      if not Cinfo^.skip then READing(dError,Rnum);

      if (Rnum>0) then begin
        system.FileMode:=2;                                    { read/write }
        WRITing(Wnum);
      end;
      if Oinfo^.skip and (not Oinfo^.eoFF) then get_next(sRc,dError);
      if (Oinfo^.eoFF)or(Oinfo^.skip) then begin
        Finfo^.WCount:=0; Finfo^.skip:=False;          { this file is ENDed }
      end else Finfo^:=Oinfo^;  { continue next READ/WRITE on the same File }
      Release(pp);
    end;
    writeln(' ':Level*Indent,Wnum,' File(s) copied by "',progName,'".');
    DEC(Level);
  end; { readWrite }

  var
    src_Fn, Dst_path : Dos.PathStr;
    Tnum, LCount : word;
begin {main}
  Get_Param( tStamp,protect,reccursion,sFile,hfile,  src_Fn,Dst_path );
  Tnum := 0;  LCount:=0;   Level:=0;  disk:=dest;
  readWrite(src_Fn,Dst_path,  tStamp,protect,reccursion,sfile,hfile,
            TNum,LCount);
  if LCount>1 then
    writeln(^m^j,TNum:(Indent+1),' File(s) copied by "',progName,'".')
end.
